<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Students extends Controller_UserEnvi {

    public function action_index()
    {
        // LOGIC
        $model = new Model_Admin_Students;
        $faculties = $model->getFaculties();
        $facultiesHandled = array(); $i = 0;
        foreach($faculties as $row)
        {
            $i++;
            $facultiesHandled[$i]['ID'] = $row['FacultyID'];
            $facultiesHandled[$i]['Name'] = $row['FacultyName'];
            $facultiesHandled[$i]['Abbr'] = $row['FacultyAbbr'];
        }
        // VIEW
        $twig = Twig::factory('admin/students/index');
        $twig->Faculties = $facultiesHandled;
        $twig->User = $this->UserInfo;
        $this->response->body($twig);        
    }
    
    public function action_add()
    {
        $model = new Model_Admin_Students();
        $faculties = $model->getFaculties();
        $facultiesHandled = array(); $i = 0;
        foreach($faculties as $row)
        {
            $i++;
            $facultiesHandled[$i]['ID'] = $row['FacultyID'];
            $facultiesHandled[$i]['Name'] = $row['FacultyName'];
            $facultiesHandled[$i]['Abbr'] = $row['FacultyAbbr'];
        }
        $twig = Twig::factory('admin/students/add');
        $twig->Faculties = $facultiesHandled;
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }
    
    public function action_upload()
    {
        if(!empty($_FILES['students'])AND $this->request->method() == 'POST')
        {
            $this->parseFile();
        }
        $model = new Model_Admin_Students;
        $faculties = $model->getFaculties();
        $facultiesHandled = array(); $i = 0;
        foreach($faculties as $row)
        {
            $i++;
            $facultiesHandled[$i]['ID'] = $row['FacultyID'];
            $facultiesHandled[$i]['Name'] = $row['FacultyName'];
            $facultiesHandled[$i]['Abbr'] = $row['FacultyAbbr'];
        }
        // VIEW
        $twig = Twig::factory('admin/students/upload');
        $twig->Faculties = $facultiesHandled;
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }
    
    protected function parseFile()
    {
        $model = new Model_Admin_Students;
        $post = Arr::map('trim', $_POST);
        $facultyID = $post['facultyID'];
        $file = fopen($_FILES["schedule"]["tmp_name"], "r");
        while ($line = fgetcsv($file, 0, ";")) 
        {
            // Имя, фамилия, отчество
            $studentName = explode(' ', $line[0]); $idx = 0;
            if(UTF8::substr($studentName[1], 0, 1) == '(')
            {
                $idx = 1;
            }
            $lastName = $studentName[0];
            $firstName = $studentName[1 + $idx];
            $secondName = '';
            for($i = 2 + $idx; $i < count(); $i++)
            {
                $secondName .= $studentName[$i].' ';
            }
            $secondName = trim($secondName);
            // Курс, степень подготовки
            $studentGradeNum = $line[1];
            switch($line[2])
            {
                case 'Бакалавр':
                    $studentDegree = 'bachelor';
                break;
                case 'Специалист':
                    $studentDegree = 'specialist';
                break;
                case 'Магистр':
                    $studentDegree = 'master';
                break;
            }
            $studentGroupNum = $line[3];
            $studentGradeID = $model->getGradeID($studentGradeNum, $studentDegree);
            Account::instance()->createStudent($lastName, $firstName, $secondName, 
                                                $studentGradeID, $studentGroupNum, $facultyID);
        }
    }
    
    public function action_edit()
    {
        $twig = Twig::factory('admin/students/edit');
        
        $twig->User = $this->UserInfo;
        $this->response->body($twig);
    }    
}
            